//
//  MyView.m
//  Ex32vdP
//
//  Created by 川上 博 on 10/04/21.
//  Copyright 2010 徳島大学. All rights reserved.
//

#import "MyView.h"
#include <math.h>

double x[2], x1[2], xm[2], ym[2], u[2], alpha[2];

void func(double x[], double f[], double t){
	f[0] = x[1];
	f[1] = 0.7*(1.0-x[0]*x[0])*x[1]-x[0];
}

void runge(int n, double h, double x[], double t){
	double k1[n],k2[n],k3[n],k4[n],xtemp[n];
	int i;
	
	func(x,k1,t);
	for (i=0; i<n; i++) xtemp[i]=x[i]+k1[i]/2.0*h;
	t+=h/2.0;
	func(xtemp,k2,t);
	for (i=0; i<n; i++) xtemp[i]=x[i]+k2[i]/2.0*h;
	func(xtemp,k3,t);
	for (i=0; i<n; i++) xtemp[i]=x[i]+k3[i]*h;
	t+=h/2.0;
	func(xtemp,k4,t);
	for (i=0; i<n; i++) x[i]+=(k1[i]+2.0*(k2[i]+k3[i])+k4[i])/6.0*h;
}

@implementation MyView

- (id)initWithFrame:(NSRect)frameRect{
	if ((self = [super initWithFrame:frameRect]) != nil){
		xm[0]=-3.0; xm[1]=3.0; ym[0]=-3.0; ym[1]=3.0;
		x[0]=0.5; x[1]=0.0;
	}
	return self;
}

- (void)drawRect:(NSRect)rect{
    double a[2],y[2],w,h;
    double tt, step=M_PI/60.0;
	int i;
	NSBezierPath *path;
	
	[[NSColor whiteColor] set];
	NSRectFill(rect);
	
	[[NSColor redColor] set];
	path = [NSBezierPath bezierPath];
	w = rect.size.width;
	h = rect.size.height;
	alpha[0] = w/(xm[1]-xm[0]);
	alpha[1] = h/(ym[1]-ym[0]);
	[path moveToPoint:NSMakePoint(0.0, h/2.0)];
	[path lineToPoint:NSMakePoint(w, h/2.0)];
	[path moveToPoint:NSMakePoint(w/2.0, 0.0)];
	[path lineToPoint:NSMakePoint(w/2.0, h)];
	[path stroke];

	[[NSColor blueColor] set];
	path = [NSBezierPath bezierPath];
	for(i=0; i<360; i++){
        tt=step*(double)i;
		y[0]=x[0]; y[1]=x[1];
		
		a[0]=alpha[0]*(y[0]-xm[0]);
		a[1]=alpha[1]*(y[1]-ym[0]);
		
		runge(2,step,x,tt);
		
		u[0]=alpha[0]*(x[0]-xm[0]);
		u[1]=alpha[1]*(x[1]-ym[0]);
		
		[path moveToPoint:NSMakePoint(a[0],a[1])];
		[path lineToPoint:NSMakePoint(u[0],u[1])];
	}
	[path stroke];
}

@end
